

#include "HMMSngl.h"

const int CellsCount = 5;

void HMM_Main(hls::stream<din_t> & din, hls::stream<dout_t> & dout)
{

	const Prob_t Coefij[CellsCount*CellsCount] = { \

		0.2, 0.3, 0.4, 0.05, 0.05, \

		0.2, 0.05, 0.3, 0.4, 0.05, \

		0.3, 0.4, 0.05, 0.2, 0.05, \

		0.2, 0.4, 0.05, 0.3, 0.05, \

		0.4, 0.05, 0.2, 0.3, 0.05

	};

	const Prob_t CellsDistr[CellsCount*QVCount] = { \

		0.2, 0.3, 0.1, 0.3, 0.05, 0.05, \

		0.2, 0.3, 0.05, 0.3, 0.1, 0.05, \

		0.1, 0.3, 0.05, 0.2, 0.3, 0.05, \

		0.3, 0.1, 0.3, 0.05, 0.2, 0.05, \

		0.1, 0.3, 0.2, 0.3, 0.05, 0.05,

	};

	static Prob_t StatesProb[CellsCount] = { 1/(double)CellsCount, 1/(double)CellsCount, 1/(double)CellsCount, 1/(double)CellsCount, 1/(double)CellsCount };

	static dout_t Total2Log = {0, 0};

for(int g = 0 ; g < Samples_Burst; g++)
{

	dout_t_v Obs = din.read().v;

	Prob_t StatesProb2[CellsCount] = {0, 0, 0, 0 ,0};

	Prob_t Sum = 0;

	int k = 0;

	HMM_Main_label0:for (int i = 0; i < CellsCount ; i++)
	{

		HMM_Main_label1:for (int j = 0 ; j < CellsCount; j++)
		{
			StatesProb2[j] += Coefij[k] *StatesProb[i];

			k++;
		}
	}

	k = 0;

	HMM_Main_label2:for (int i = 0; i < CellsCount ; i++)
	{
		StatesProb[i] = StatesProb2[i]*CellsDistr[k + FindV(Obs)];

		k += QVCount;

		Sum += StatesProb[i];
	}

	HMM_Main_label3:for (int i = 0; i < CellsCount ; i++)
	{
		StatesProb[i] /=Sum;

	}

	Total2Log.v += (dout_t_v)log((double)Sum);

	if(g == Samples_Burst-1) Total2Log.last = 1;

	dout.write(Total2Log);
}

return;
}

QV_t FindV(din_t_v din)
{
	const din_t_v Book[QVCount] = {20, 60, 400, 600, 700, 1000 };

	for(int i = 0 ; i < QVCount; i++)
	{
		if(din < Book[i]) return i;
	}

	return 0;

};

