#ifndef HLS_HMMSNGL_H_
#define HLS_HMMSNGL_H_

#include <ap_fixed.h>
#include <hls_stream.h>

#define Samples_Burst 10
#define DIN_W 16
#define DOUT_W DIN_W
#define QV_W 3
#define Cells_W 5 // to index cells matrix
#define QVCount 6
// User guide page 206

typedef ap_int<DIN_W> din_t_v;
typedef ap_fixed<DIN_W, 10, AP_TRN, AP_SAT>  dout_t_v;

class din_t
{
	public:
	din_t_v v;
	ap_uint<1>  last;
};

class dout_t
{
	public:
	dout_t_v v;
	ap_uint<1>  last;
};

typedef ap_int<QV_W> QV_t;

typedef ap_fixed<DIN_W, 1, AP_TRN, AP_SAT> Prob_t; // MUST have IW >= 1

void HMM_Main(hls::stream<din_t> & , hls::stream<dout_t> & );

QV_t FindV(din_t_v din);

#endif
